import { LemonStore } from './LemonStore';
import { ValueInfo, Subscriber } from './types';
export declare class SharedData {
    private removedValues;
    private stores;
    subscribersMap: Map<symbol, () => Subscriber<any>[]>;
    proxyLinkUpdaters: Map<symbol, () => void>;
    computeChainProp: Set<symbol>;
    changedValues: Set<symbol>;
    needUpdateValues: Set<symbol>;
    valueMap: Map<symbol, ValueInfo>;
    activeComputingValueId?: symbol;
    resolvedValues?: Set<symbol>;
    nullLastValueSymbol: symbol;
    clearWork(): void;
    getStoreById(id: symbol): LemonStore<any>;
    throwError(ErrorConstructor: any, message: string): never;
    getValueInfo(valueId: symbol): ValueInfo;
    getValueInfoByStateProp(stateValues: Map<string, symbol>, propName: string): ValueInfo;
    registerChangedValue(valueId: symbol): void;
    registerStore(storeId: symbol, store: LemonStore<any>, getSubscribers: () => Subscriber<any>[], getUpdateProxyLink: () => void): void;
    removeStoreValues(values: Set<symbol>): void;
    removeStoreSubscribers(storeId: symbol): void;
    removeStoreProxyLinkUpdater(storeId: symbol): void;
    canSetState(): boolean;
}
