"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const is_plain_object_1 = __importDefault(require("is-plain-object"));
exports.propertyListener = (data) => {
    if (!is_plain_object_1.default(data)) {
        throw new Error('Data must be a plain object!');
    }
    let proxy = {};
    let isActive = true;
    const usedKeys = new Set();
    Object.keys(data).forEach((property) => {
        Object.defineProperty(proxy, property, {
            enumerable: true,
            configurable: true,
            set: (value) => data[property] = value,
            get: () => {
                if (isActive) {
                    usedKeys.add(property);
                }
                return data[property];
            }
        });
    });
    return {
        getProxy: () => isActive && proxy ? proxy : data,
        getUsedkeys: () => usedKeys,
        isActive: () => isActive,
        stop: () => {
            isActive = false;
            proxy = null;
        }
    };
};
